# PAbstractDictionary Class Reference

An abstract dictionary container. More...

`#include <dict.h>`

Inheritance diagram for PAbstractDictionary:

List of all members.

## Public Member Functions

Construction
PINLINE | PAbstractDictionary ()
| Create a new, empty, dictionary.
Overrides from class PObject
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream.
Overrides from class PCollection
virtual PINDEX | Insert (const PObject &key, PObject *obj)
| Insert a new object into the dictionary.
virtual PINDEX | InsertAt (PINDEX index, PObject *obj)
| Insert a new object at the specified index.
virtual PObject * | RemoveAt (PINDEX index)
| Remove an object at the specified index.
virtual PBoolean | SetAt (PINDEX index, PObject *val)
| Set the object at the specified index to the new value.
virtual PObject * | GetAt (PINDEX index) const
| Get the object at the specified index position.
virtual PINDEX | GetObjectsIndex (const PObject *obj) const
| Search the collection for the specific instance of the object.
virtual PINDEX | GetValuesIndex (const PObject &obj) const
| Search the collection for the specified value of the object.
New functions for class
virtual PBoolean | SetDataAt (PINDEX index, PObject *obj)
| Set the data at the specified ordinal index position in the dictionary.
virtual PBoolean | AbstractSetAt (const PObject &key, PObject *obj)
| Add a new object to the collection.
virtual PObject & | GetRefAt (const PObject &key) const
| Get the object at the specified key position.
virtual PObject * | AbstractGetAt (const PObject &key) const
| Get the object at the specified key position.
virtual void | AbstractGetKeys (PArrayObjects &keys) const
| Get an array containing all the keys for the dictionary.

## Protected Member Functions

PINLINE | PAbstractDictionary (int dummy, const PAbstractDictionary *c)

## Detailed Description

An abstract dictionary container.

## Constructor & Destructor Documentation

PINLINE PAbstractDictionary::PAbstractDictionary | ( |  | ) |

Create a new, empty, dictionary.

Note that by default, objects placed into the dictionary will be deleted when removed or when all references to the dictionary are destroyed.

PINLINE PAbstractDictionary::PAbstractDictionary | ( | int | dummy,
|  | const PAbstractDictionary * | c |
| ) |  |  | `[protected]`

## Member Function Documentation

virtual PObject* PAbstractDictionary::AbstractGetAt | ( | const PObject & | key | ) | const`[virtual]`

Get the object at the specified key position.

If the key was not in the collection then NULL is returned.

Returns:
  pointer to object at the specified key.

Parameters:

  key | Key for position in dictionary to get object.

virtual void PAbstractDictionary::AbstractGetKeys | ( | PArrayObjects & | keys | ) | const`[virtual]`

Get an array containing all the keys for the dictionary.

virtual PBoolean PAbstractDictionary::AbstractSetAt | ( | const PObject & | key,
|  | PObject * | obj |
| ) |  |  | `[virtual]`

Add a new object to the collection.

If the objects value is already in the dictionary then the object is overrides the previous value. If the AllowDeleteObjects option is set then the old object is also deleted.

The object is placed in the an ordinal position dependent on the keys hash function. Subsequent searches use the hash function to speed access to the data item.

Returns:
  true if the object was successfully added.

Parameters:

  key | Key for position in dictionary to add object.
  obj | New object to put into the dictionary.

virtual PObject* PAbstractDictionary::GetAt | ( | PINDEX | index | ) | const`[virtual]`

Get the object at the specified index position.

If the index was not in the collection then NULL is returned.

Returns:
  pointer to object at the specified index.

Parameters:

  index | Index position in the collection of the object.

Implements PCollection.

virtual PINDEX PAbstractDictionary::GetObjectsIndex | ( | const PObject * | obj | ) | const`[virtual]`

Search the collection for the specific instance of the object.

The object pointers are compared, not the values. The hash table is used to locate the entry.

Note that that will require value comparisons to be made to find the equivalent entry and then a final check is made with the pointers to see if they are the same instance.

Returns:
  ordinal index position of the object, or P_MAX_INDEX.

Parameters:

  obj | Object to find.

Implements PCollection.

virtual PObject& PAbstractDictionary::GetRefAt | ( | const PObject & | key | ) | const`[virtual]`

Get the object at the specified key position.

If the key was not in the collection then this function asserts.

This function is primarily for use by the operator[] function in the descendent template classes.

Returns:
  reference to object at the specified key.

Parameters:

  key | Key for position in dictionary to get object.

virtual PINDEX PAbstractDictionary::GetValuesIndex | ( | const PObject & | obj | ) | const`[virtual]`

Search the collection for the specified value of the object.

The object values are compared, not the pointers. So the objects in the collection must correctly implement the `PObject::Compare()` function. The hash table is used to locate the entry.

Returns:
  ordinal index position of the object, or P_MAX_INDEX.

Parameters:

  obj | Object to find value of.

Implements PCollection.

virtual PINDEX PAbstractDictionary::Insert | ( | const PObject & | key,
|  | PObject * | obj |
| ) |  |  | `[virtual]`

Insert a new object into the dictionary.

The semantics of this function is different from that of the `PCollection` class. This function is exactly equivalent to the `SetAt()` function that sets a data value at the key value location.

Returns:
  Always zero.

Parameters:

  key | Object value to use as the key.
  obj | New object to place into the collection.

Implements PCollection.

virtual PINDEX PAbstractDictionary::InsertAt | ( | PINDEX | index,
|  | PObject * | obj |
| ) |  |  | `[virtual]`

Insert a new object at the specified index.

This function only applies to derived classes whose key is PINDEX based.

Returns:
  `index` parameter.

Parameters:

  index | Index position in collection to place the object.
  obj | New object to place into the collection.

Implements PCollection.

virtual void PAbstractDictionary::PrintOn | ( | ostream & | strm | ) | const`[virtual]`

Output the contents of the object to the stream.

The exact output is dependent on the exact semantics of the descendent class. This is primarily used by the standard `operator<<` function.

The default behaviour is to print the class name.

Parameters:

  strm | Stream to print the object into.

Reimplemented from PCollection.

Reimplemented in PMIMEInfo.

virtual PObject* PAbstractDictionary::RemoveAt | ( | PINDEX | index | ) | `[virtual]`

Remove an object at the specified index.

This function only applies to derived classes whose key is PINDEX based. The returned pointer is then removed using the `SetAt()` function to set that key value to NULL. If the `AllowDeleteObjects` option is set then the object is also deleted.

Returns:
  pointer to the object being removed, or NULL if it was deleted.

Parameters:

  index | Index position in collection to place the object.

Implements PCollection.

virtual PBoolean PAbstractDictionary::SetAt | ( | PINDEX | index,
|  | PObject * | val |
| ) |  |  | `[virtual]`

Set the object at the specified index to the new value.

This function only applies to derived classes whose key is PINDEX based. This will overwrite the existing entry. If the AllowDeleteObjects() option is set then the old object is also deleted.

Returns:
  true if the object was successfully added.

Parameters:

  index | Index position in collection to set.
  val | New value to place into the collection.

Implements PCollection.

virtual PBoolean PAbstractDictionary::SetDataAt | ( | PINDEX | index,
|  | PObject * | obj |
| ) |  |  | `[virtual]`

Set the data at the specified ordinal index position in the dictionary.

The ordinal position in the dictionary is determined by the hash values of the keys and the order of insertion.

Returns:
  true if the new object could be placed into the dictionary.

Parameters:

  index | Ordinal index in the dictionary.
  obj | New object to put into the dictionary.

The documentation for this class was generated from the following file:

- dict.h